{ me jmeno je 22 }

unit FormsMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, ActnList, Menus;

type
  TPersonID = string;
  TPerson = packed record
    id: TPersonID;
    name: string;
    surname: string;
    gender: Char;
    birth: string;
    death: string;
    mother: TPersonID;
    father: TPersonID;
  end;

  TPersonList = array of TPerson;

  TfrmPersonList = class(TForm)
    lsvPersonList: TListView;
    ppmPersonView: TPopupMenu;
    aclPersonList: TActionList;
    actAddPerson: TAction;
    mniAddPerson: TMenuItem;
    actRemovePerson: TAction;
    mniRemovePerson: TMenuItem;
    MainMenu1: TMainMenu;
    actLoadPersonList: TAction;
    opdPersonLoad: TOpenDialog;
    mniLoadPersonList: TMenuItem;
    mniFileMenu: TMenuItem;
    actShowDetails: TAction;
    mniShowDetails: TMenuItem;
    N1: TMenuItem;
    actSavePersonList: TAction;
    mniSavePersonList: TMenuItem;
    svdPersonSave: TSaveDialog;
    actAppendPersonList: TAction;
    mniAppendPersonLists: TMenuItem;
    mniEdit: TMenuItem;
    Pidatosobu1: TMenuItem;
    Smazatosobu1: TMenuItem;
    N2: TMenuItem;
    Vlastnosti1: TMenuItem;
    actModifyPerson: TAction;
    mniModifyPerson: TMenuItem;
    Upravitosobu1: TMenuItem;
    actSearchPartner: TAction;
    Najdivhodnhopartnera1: TMenuItem;
    N3: TMenuItem;
    Najdivhodnhopartnera2: TMenuItem;
    N4: TMenuItem;
    procedure actAddPersonExecute(Sender: TObject);
    procedure actRemovePersonExecute(Sender: TObject);
    procedure actRemovePersonUpdate(Sender: TObject);
    procedure actLoadPersonListExecute(Sender: TObject);
    procedure actShowDetailsExecute(Sender: TObject);
    procedure lsvPersonListSelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure actSavePersonListExecute(Sender: TObject);
    procedure actModifyPersonExecute(Sender: TObject);
    procedure actAppendPersonListExecute(Sender: TObject);
    procedure actSearchPartnerExecute(Sender: TObject);
  private
    FPersonList: TPersonList;
    function GetPersonCount: Integer;
    function GetPersons(Index: Integer): TPerson;
    function GetSearch(ID: string): TPerson;
    function GetSearchI(ID: string): Integer;
  public
    procedure LoadPersonList(FileName: string);
    procedure SavePersonList(FileName: string);
    procedure RefreshView;
    property Persons[Index: Integer]: TPerson read GetPersons;
    property Search[ID: string]: TPerson read GetSearch;
    property SearchI[ID: string]: Integer read GetSearchI;
    property PersonCount: Integer read GetPersonCount;
  end;

var
  frmPersonList: TfrmPersonList;

implementation

uses FormsGetPersonInfo, FormsProperties, FormsSearchPartner;

{$R *.DFM}

function StrToDate(Date: string): TDate;
begin
  try
    Result := SysUtils.StrToDate(Date);
  except
    Result := StrToInt(Date) * 365;
  end;
end;

procedure TfrmPersonList.RefreshView;
var
  I: Integer;
  NewPers: TListItem;
begin
  with lsvPersonList.Items do begin
    BeginUpdate;
    try
      Clear;
      for I := 0 to Length(FPersonList) - 1 do begin
        NewPers := Add;
        with FPersonList[I] do begin
          NewPers.Caption := name;
          NewPers.SubItems.Add(surname);
          NewPers.SubItems.Add(birth);
          NewPers.SubItems.Add(death);
          NewPers.SubItems.Add(mother);
          NewPers.SubItems.Add(father);
          NewPers.SubItems.Add(gender);
          NewPers.SubItems.add(id);
        end;
      end;
    finally
      EndUpdate;
    end;
  end;
end;

procedure TfrmPersonList.actAddPersonExecute(Sender: TObject);
begin
  // Ziskejme informace z dialogu
  with TfrmGetPersonInfo.Create(Self) do try
    if ShowModal = mrOK then begin
      // Validita osoby by mela byt jiz zkontrolovana
      SetLength(FPersonList, PersonCount + 1);
      with FPersonList[PersonCount - 1] do begin
        id := edtID.Text;
        name := edtName.Text;
        surname := edtSurname.Text;
        if rdbMale.Checked then
          gender := 'M'
        else
          gender := 'Z';
        birth := edtBirthdate.Text;
        death := edtDeathdate.Text;
        if cmbMother.Text <> '<neznm>' then
          mother := copy(cmbMother.Text, 2, Pos('>', cmbMother.Text) - 2);
        if cmbFather.Text <> '<neznm>' then
          father := copy(cmbFather.Text, 2, Pos('>', cmbFather.Text) - 2);
      end;
    end;
  finally
    Free;
    RefreshView;
  end;
end;

function TfrmPersonList.GetPersonCount: Integer;
begin
  Result := Length(FPersonList);
end;

function TfrmPersonList.GetPersons(Index: Integer): TPerson;
begin
  Result := FPersonList[index];
end;

procedure TfrmPersonList.actRemovePersonExecute(Sender: TObject);
var
  I: Integer;
begin
  try
    for I := lsvPersonList.Selected.Index to PersonCount - 2 do
      FPersonList[I] := FPersonList[I + 1];
    SetLength(FPersonList, PersonCount - 1);
  finally
    RefreshView;
  end;
end;

procedure TfrmPersonList.actRemovePersonUpdate(Sender: TObject);
begin
  actRemovePerson.Enabled := Assigned(lsvPersonList.Selected);
  actModifyPerson.Enabled := Assigned(lsvPersonList.Selected);
  actShowDetails.Enabled := Assigned(lsvPersonList.Selected);
  actSearchPartner.Enabled := Assigned(lsvPersonList.Selected) and (Persons[lsvPersonList.Selected.Index].birth <> '');
end;

procedure TfrmPersonList.actLoadPersonListExecute(Sender: TObject);
begin
  if opdPersonLoad.Execute then
    LoadPersonList(opdPersonLoad.FileName);
end;

procedure TfrmPersonList.LoadPersonList(FileName: string);

  procedure ParseXML(Source: string; List: TStrings);
  var
    I: Integer;
    CurrLine: Integer;
    State: Integer;
      // 1 = mimo tag
      // 0 = uvnitr tagu
  begin
    List.Add('');
    // sude radky obsahuji tag, liche text
    CurrLine := -1;
    State := 1;
    for I := 1 to Length(Source) - 1 do
      case State of
        0:
          if Source[I] = '>' then begin
            CurrLine := CurrLine + 1;
            State := 1;
            List.Add('');
          end else
            if not (Source[I] in [#1..#32]) then
              List[CurrLine] := List[CurrLine] + Source[I];
        1:
          if CurrLine <> -1 then
            if Source[I] = '<' then begin
              State := 0;
              CurrLine := CurrLine + 1;
              List.add('');
            end else
              // vynechejme newline
              if not (Source[I] in [#1..#31]) then
                List[CurrLine] := List[CurrLine] + Source[I]
              else
          else
            if Source[I] = '<' then begin
              CurrLine := 0;
              State := 0;
            end;
      end;


  end;

var
  SourceText: string;
  Elem: TStringList;
  CurrElem: Integer;
  Person: TPerson;
begin
  with TStringList.Create do try
    LoadFromFile(FileName);
    SourceText := Text;
  finally
    Free;
  end;

  SetLength(FPersonList, 0);

  // Nyn mm v SourceText vstupn XML soubor
  Elem := TStringList.Create;
  try
    ParseXML(SourceText, Elem);
    // ted mame rozdelene tagy a text
    if Elem[0] <> 'rodokmen' then
      raise Exception.Create('Chybny format souboru');
    CurrElem := 2;
    while CurrElem < Elem.Count do begin
      if Elem[CurrElem] = '/osoba' then begin
        SetLength(FPersonList, PersonCount + 1);
        FPersonList[PersonCount - 1] := Person;
      end;
      if Elem[CurrElem] = 'id' then
        Person.id := Elem[CurrElem + 1];
      if Elem[CurrElem] = 'jmeno' then
        Person.name := Elem[CurrElem + 1];
      if Elem[CurrElem] = 'prijmeni' then
        Person.surname := Elem[CurrElem + 1];
      if Elem[CurrElem] = 'pohlavi' then
        Person.gender := Elem[CurrElem + 1][1];
      if Elem[CurrElem] = 'narozeni' then
        Person.birth := Elem[CurrElem + 1];
      if Elem[CurrElem] = 'umrti' then
        Person.death := Elem[CurrElem + 1];
      if Elem[CurrElem] = 'matka' then
        Person.mother := Elem[CurrElem + 1];
      if Elem[CurrElem] = 'otec' then
        Person.father := Elem[CurrElem + 1];
      if Elem[CurrElem] = 'jmeno/' then
        Person.name := '';
      if Elem[CurrElem] = 'prijmeni/' then
        Person.surname := '';
      if Elem[CurrElem] = 'pohlavi/' then
        Person.gender := ' ';
      if Elem[CurrElem] = 'narozeni/' then
        Person.birth := '';
      if Elem[CurrElem] = 'umrti/' then
        Person.death := '';
      if Elem[CurrElem] = 'matka/' then
        Person.mother := '';
      if Elem[CurrElem] = 'otec/' then
        Person.father := '';
      CurrElem := CurrElem + 2;
    end;
  finally
    Elem.Free;
    RefreshView;
  end;
end;

procedure TfrmPersonList.actShowDetailsExecute(Sender: TObject);
begin
  frmProperties.Show;
end;

procedure TfrmPersonList.lsvPersonListSelectItem(Sender: TObject;
  Item: TListItem; Selected: Boolean);
begin
  if not Selected then Exit; 
  if Assigned(Item) then
    frmProperties.Current := Item.Index
  else
    frmProperties.Current := -1;
end;

function TfrmPersonList.GetSearch(ID: string): TPerson;
var
  I: Integer;
begin
  I := GetSearchI(ID);
  if I = -1 then
    Result.gender := ' '
  else
    Result := Persons[I];
end;

function TfrmPersonList.GetSearchI(ID: string): Integer;
var
  I: Integer;
begin
  Result := -1;
  for I := 0 to PersonCount - 1 do
    if Persons[I].ID = ID then begin
      Result := I;
      Break;
    end;
end;

procedure TfrmPersonList.actSavePersonListExecute(Sender: TObject);
begin
  if svdPersonSave.Execute then
    SavePersonList(svdPersonSave.FileName);
end;

procedure TfrmPersonList.SavePersonList(FileName: string);
var
  SList: TStringList;
  I: Integer;
begin
  SList := TStringList.Create;
  try
    SList.Add('<rodokmen>');
    for I := 0 to PersonCount - 1 do begin
      SList.Add('  <osoba>');
      with Persons[I] do begin
        SList.Add(Format('    <id>%s</id>', [id]));
        if name = '' then
          SList.Add('    <jmeno/>')
        else
          SList.Add(Format('    <jmeno>%s</jmeno>', [name]));

        if surname = '' then
          SList.Add('    <prijmeni/>')
        else
          SList.Add(Format('    <prijmeni>%s</prijmeni>', [surname]));

        if gender = '' then
          SList.Add('    <pohlavi/>')
        else
          SList.Add(Format('    <pohlavi>%s</pohlavi>', [gender]));

        if birth = '' then
          SList.Add('    <narozeni/>')
        else
          SList.Add(Format('    <narozeni>%s</narozeni>', [birth]));

        if death = '' then
          SList.Add('    <umrti/>')
        else
          SList.Add(Format('    <umrti>%s</umrti>', [death]));

        if mother = '' then
          SList.Add('    <matka/>')
        else
          SList.Add(Format('    <matka>%s</matka>', [mother]));

        if father = '' then
          SList.Add('    <otec/>')
        else
          SList.Add(Format('    <otec>%s</otec>', [father]));
      end;
      SList.Add('  </osoba>');
    end;
    SList.Add('</rodokmen>');
    SList.SaveToFile(FileName);
  finally
    SList.Free;
  end;
end;

procedure TfrmPersonList.actModifyPersonExecute(Sender: TObject);
var
  back: string;
  i: integer;
begin
  with TfrmGetPersonInfo.Create(Self) do try
    with FPersonList[lsvPersonList.Selected.Index] do begin
      edtID.Text := id;
      back := id;
      id := '';
      edtName.Text := name;
      edtSurname.Text := surname;
      if gender = 'M' then
        rdbMale.Checked := True
      else
        rdbFemale.Checked := True;
      edtBirthDate.Text := birth;
      edtDeathDate.Text := death;
      if mother = '' then
        cmbMother.ItemIndex := cmbMother.Items.Count - 1
      else
        for I := 0 to cmbMother.Items.Count - 1 do
          if Copy(cmbMother.Items[I], 2, Pos('>', cmbMother.Items[I]) - 2) = mother then begin
            cmbMother.ItemIndex := I;
            Break;
          end;
      if father = '' then
        cmbfather.ItemIndex := cmbfather.Items.Count - 1
      else
        for I := 0 to cmbFather.Items.Count - 1 do
          if Copy(cmbFather.Items[I], 2, Pos('>', cmbFather.Items[I]) - 2) = father then begin
            cmbFather.ItemIndex := I;
            Break;
          end;
    end;
    if ShowModal = mrOK then
      with FPersonList[lsvPersonList.Selected.Index] do begin
        id := edtID.Text;
        name := edtName.Text;
        surname := edtSurname.Text;
        if rdbMale.Checked then
          gender := 'M'
        else
          gender := 'Z';
        birth := edtBirthdate.Text;
        death := edtDeathdate.Text;
        if cmbMother.Text <> '<neznm>' then
          mother := copy(cmbMother.Text, 2, Pos('>', cmbMother.Text) - 2);
        if cmbFather.Text <> '<neznm>' then
          father := copy(cmbFather.Text, 2, Pos('>', cmbFather.Text) - 2);
      end
    else
      FPersonList[lsvPersonList.Selected.Index].id := back;
  finally
    Free;
    RefreshView;
  end
end;

procedure TfrmPersonList.actAppendPersonListExecute(Sender: TObject);
var
  Backup: TPersonList;
  I, J: Integer;
begin
  Backup := FPersonList;
  actLoadPersonList.Execute;

  // slucme nyni backup a FPersonlist
  for I := Length(Backup) - 1 downto 0 do
    while SearchI[Backup[I].id] <> -1 do begin
      for J := 0 to Length(Backup) - 1 do begin
        if Backup[J].mother = backup[i].id then
          Backup[J].mother := Backup[I].id + '0';
        if Backup[J].father = backup[i].id then
          Backup[J].father := Backup[I].id + '0';
      end;
      Backup[i].id := Backup[I].id + '0';
    end;

  SetLength(FPersonList, PersonCount + Length(Backup));
  for I := 0 to length(Backup) - 1 do
    FPersonList[PersonCount - length(backup) + i] := Backup[i];

  RefreshView;
end;

procedure TfrmPersonList.actSearchPartnerExecute(Sender: TObject);
var
  I: Integer;
  Subject: TPerson;
begin
  with TfrmSearchPartner.Create(Self) do try
    cmbPersons.ItemIndex := lsvPersonList.Selected.Index;
    if ShowModal = mrOK then begin
      Subject := Persons[cmbPersons.ItemIndex];
      for I := 0 to PersonCount - 1 do begin
        if (persons[i].birth = '') or (subject.birth = '') then Continue; 
        if (Persons[I].gender <> Subject.gender) and (Abs(StrToDate(Persons[I].birth) - StrToDate(Subject.birth)) < (updYear.Position * 365))
          and (Persons[I].mother <> subject.id) and (Persons[I].father <> subject.id)
          and (Subject.mother <> persons[i].id) and (subject.father <> persons[I].id)
          and (persons[I].mother <> subject.mother) and (persons[i].father <> subject.father)
//          and {babicky a dedove} 
          then begin
          lsvPersonList.Selected := lsvPersonList.Items[I];
          Break;
        end;
      end;
    end;
  finally
    Free;
  end;
end;

end.
