unit FormsProperties;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TfrmProperties = class(TForm)
    lblPerson: TLabel;
    btnFather: TButton;
    lblFather: TLabel;
    btnMother: TButton;
    lblMother: TLabel;
    btnMotherGrandMo: TButton;
    lblMotherGrandMo: TLabel;
    btnMotherGrandPa: TButton;
    lblMotherGrandPa: TLabel;
    btnFatherGrandMo: TButton;
    lblFatherGrandMo: TLabel;
    btnFatherGrandPa: TButton;
    lblFatherGrandPa: TLabel;
    btnHusbands: TButton;
    Button8: TButton;
    Button9: TButton;
    Button10: TButton;
    Button11: TButton;
    Button12: TButton;
    Button13: TButton;
    Button14: TButton;
    Button15: TButton;
    procedure btnMotherClick(Sender: TObject);
    procedure btnFatherClick(Sender: TObject);
    procedure btnMotherGrandMoClick(Sender: TObject);
    procedure btnMotherGrandPaClick(Sender: TObject);
    procedure btnFatherGrandPaClick(Sender: TObject);
    procedure btnFatherGrandMoClick(Sender: TObject);
    procedure btnHusbandsClick(Sender: TObject);
  private
    FCurrent: Integer;
    procedure SetCurrent(const Value: Integer);
    { Private declarations }
  public
    property Current: Integer read FCurrent write SetCurrent;
    procedure Regenerate;
  end;

var
  frmProperties: TfrmProperties;

implementation

uses FormsMain, FormsSearchRes;

{$R *.DFM}

{ TfrmProperties }

procedure TfrmProperties.Regenerate;
const
  Genders: array[Boolean] of string = ('Mu', 'ena');
var
  SR: TPerson;
begin
  if Current = -1 then Exit;
  with frmPersonList, Persons[Current] do begin
    lblPerson.Caption := Format('<%s> %s %s (%s)', [id, name, surname, Genders[gender <> 'M']]);
    SR := Search[mother];
    if SR.gender <> ' ' then with SR do
      lblMother.Caption := Format('<%s> %s %s (%s)', [id, name, surname, Genders[gender <> 'M']])
    else
      lblMother.Caption := '<neznm>';
    btnMother.Enabled := SR.gender <> ' ';

    SR := Search[father];
    if SR.gender <> ' ' then with SR do
      lblFather.Caption := Format('<%s> %s %s (%s)', [id, name, surname, Genders[gender <> 'M']])
    else
      lblFather.Caption := '<neznm>';
    btnFather.Enabled := SR.gender <> ' ';

    // deda z otcovy strany
    SR := Search[father];
    SR := Search[SR.father];
    if SR.gender <> ' ' then with SR do
      lblFatherGrandPa.Caption := Format('<%s> %s %s (%s)', [id, name, surname, Genders[gender <> 'M']])
    else
      lblFatherGrandPa.Caption := '<neznm>';
    btnFatherGrandPa.Enabled := SR.gender <> ' ';

    SR := Search[father];
    SR := Search[SR.mother];
    if SR.gender <> ' ' then with SR do
      lblFatherGrandMo.Caption := Format('<%s> %s %s (%s)', [id, name, surname, Genders[gender <> 'M']])
    else
      lblFatherGrandMo.Caption := '<neznm>';
    btnFatherGrandMo.Enabled := SR.gender <> ' ';

    SR := Search[mother];
    SR := Search[SR.mother];
    if SR.gender <> ' ' then with SR do
      lblMotherGrandMo.Caption := Format('<%s> %s %s (%s)', [id, name, surname, Genders[gender <> 'M']])
    else
      lblMotherGrandMo.Caption := '<neznm>';
    btnMotherGrandMo.Enabled := SR.gender <> ' ';

    SR := Search[mother];
    SR := Search[SR.father];
    if SR.gender <> ' ' then with SR do
      lblMotherGrandPa.Caption := Format('<%s> %s %s (%s)', [id, name, surname, Genders[gender <> 'M']])
    else
      lblMotherGrandPa.Caption := '<neznm>';
    btnMotherGrandPa.Enabled := SR.gender <> ' ';
  end;
end;

procedure TfrmProperties.SetCurrent(const Value: Integer);
begin
  if (FCurrent <> Value) then begin
    FCurrent := Value;
    frmPersonList.lsvPersonList.Selected := frmPersonList.lsvPersonList.Items[Current]; 
    Regenerate;
  end;
end;

procedure TfrmProperties.btnMotherClick(Sender: TObject);
begin
  Current := frmPersonList.SearchI[frmPersonList.Persons[Current].mother];
end;

procedure TfrmProperties.btnFatherClick(Sender: TObject);
begin
  Current := frmPersonList.SearchI[frmPersonList.Persons[Current].father];
end;

procedure TfrmProperties.btnMotherGrandMoClick(Sender: TObject);
begin
  Current := frmPersonList.SearchI[frmPersonList.Persons[Current].mother];
  Current := frmPersonList.SearchI[frmPersonList.Persons[Current].mother];
end;

procedure TfrmProperties.btnMotherGrandPaClick(Sender: TObject);
begin
  Current := frmPersonList.SearchI[frmPersonList.Persons[Current].mother];
  Current := frmPersonList.SearchI[frmPersonList.Persons[Current].father];
end;

procedure TfrmProperties.btnFatherGrandPaClick(Sender: TObject);
begin
  Current := frmPersonList.SearchI[frmPersonList.Persons[Current].father];
  Current := frmPersonList.SearchI[frmPersonList.Persons[Current].father];
end;

procedure TfrmProperties.btnFatherGrandMoClick(Sender: TObject);
begin
  Current := frmPersonList.SearchI[frmPersonList.Persons[Current].father];
  Current := frmPersonList.SearchI[frmPersonList.Persons[Current].mother];
end;

procedure TfrmProperties.btnHusbandsClick(Sender: TObject);
begin
  frmSearch.Show;
  frmSearch.SeShow(sfwHusband, frmPersonList.Persons[Current]);
end;

end.
